package jp.sf.amateras.xmleditor.editors;

import jp.sf.amateras.xmleditor.preferences.PreferenceConstants;

import org.eclipse.jface.text.*;
import org.eclipse.jface.text.rules.*;

public class XMLTagScanner extends RuleBasedScanner {
	
	private ColorManager manager;
	
	public XMLTagScanner(ColorManager manager) {
		this.manager = manager;
		initialize();
	}
	
	public void initialize(){
		setDefaultReturnToken(
				new Token(
						new TextAttribute(
							manager.getColor(PreferenceConstants.COLOR_TAG))));
		
		IToken string =
			new Token(
				new TextAttribute(manager.getColor(PreferenceConstants.COLOR_STRING)));

		IRule[] rules = new IRule[3];

		// Add rule for double quotes
		rules[0] = new SingleLineRule("\"", "\"", string, '\\');
		// Add a rule for single quotes
		rules[1] = new SingleLineRule("'", "'", string, '\\');
		// Add generic whitespace rule.
		rules[2] = new WhitespaceRule(new XMLWhitespaceDetector());

		setRules(rules);
	}
}
